﻿<%@ Page Title="Home Page" Language="C#" MasterPageFile="~/Site.Master" AutoEventWireup="true" CodeBehind="Default.aspx.cs" Inherits="EnsureTemplate._Default" %>

<%@ Register Assembly="AjaxControlToolkit" Namespace="AjaxControlToolkit" TagPrefix="cc1" %>
<%@ Register Assembly="Infragistics4.Web.v13.2, Version=13.2.20132.2077, Culture=neutral, PublicKeyToken=7dd5c3163f2cd0cb" Namespace="Infragistics.Web.UI.ListControls" TagPrefix="ig" %>
<%@ Register Assembly="Infragistics4.Web.v13.2, Version=13.2.20132.2077, Culture=neutral, PublicKeyToken=7dd5c3163f2cd0cb" Namespace="Infragistics.Web.UI.NavigationControls" TagPrefix="ig" %>
<%@ Register Assembly="Infragistics4.Web.v13.2, Version=13.2.20132.2077, Culture=neutral, PublicKeyToken=7dd5c3163f2cd0cb" Namespace="Infragistics.Web.UI" TagPrefix="ig" %>

<asp:Content ID="BodyContent" ContentPlaceHolderID="MainContent" runat="server">

    <script type="text/javascript">
        var REQUIREMENT_VALUE = 'Requirement';
        var MAY_HAVE_SUBREQS_VALUE = 'MayHaveSubReqs';
        var REF_ID_INDEX = 1;

        // scroll up or down if an item is dragged outside the viewing area.
        function dragMove(sender, args) {
            var distanceToEdge = 30;
            var scrollSpeed = 5;
            var y = args.get_y();
            var windowHeight = $(window).height();
            var scrollTop = $(window).scrollTop();
            if (y > (windowHeight + scrollTop) - distanceToEdge) {
                scrollBy(0, scrollSpeed);
            } else if (y < (scrollTop + distanceToEdge)) {
                scrollBy(0, -scrollSpeed);
            }
        }

        // cancel the drop if it is not a valid drop
        function nodeDropping(sender, args) {
            alert("hello");
            var sourceNode = args.get_sourceNodes()[0];
            var destNode = args.get_destNode();
            var isDroppedOn = (args.get_dragDropPoint() == $IG.DragDropPoint.On);
            var isSourceRequirement = isRequirementNode(sourceNode);
            var isDestRequirement = isRequirementNode(destNode);
            var isDestOnTrunk = (destNode.get_parentNode() == null);
            var isSourceOnTrunk = (sourceNode.get_parentNode() == null);
            var destReqNode = destNode;
            if (!isDestRequirement || !isDroppedOn) {
                destReqNode = destNode.get_parentNode();
            }
            var mayDestRequirementHaveSubReqs = true;
            if (destReqNode !== null) {
                mayDestRequirementHaveSubReqs = mayHaveSubrequirements(destReqNode);
            }
            var mayDestParentRequirementHaveSubReqs = !isDestOnTrunk && (mayHaveSubrequirements(destNode));
            var cancelDropping = false;
            //may not drop a requirement on an element
            cancelDropping = (isDroppedOn && isSourceRequirement && !isDestRequirement);
            //alert("1 " + cancelDropping);
            // may not drop a requirement on a requirement that can't have subrequirements
            cancelDropping = (cancelDropping || (isSourceRequirement && !mayDestRequirementHaveSubReqs));
            //alert("2 " + cancelDropping);
            // may not drop an element on an element
            cancelDropping = (cancelDropping || (isDroppedOn && !isSourceRequirement && !isDestRequirement));
            //alert("3 " + cancelDropping);
            // may not drop an element between trunk nodes
            cancelDropping = (cancelDropping || (!isDroppedOn && isDestOnTrunk && !isSourceRequirement));
            //alert("4 " + cancelDropping);
            // may not drop an element into a different requirement that already has an element with the same reference id
            //alert(getReferenceId(sourceNode));
            cancelDropping = (cancelDropping || (!isSourceRequirement && (sourceNode.get_parentNode() != destReqNode && requestNodeContainsreferenceElement(getReferenceId(sourceNode), destReqNode))));
            //alert("5 " + cancelDropping);
            // may not re-order root items
            //cancelDropping = (cancelDropping || (!isDroppedOn && isSourceOnTrunk && isDestOnTrunk));
            //alert("6 " + cancelDropping);
            args.set_cancel(cancelDropping);
            //   setText(cancelDropping);
        }


        function isRequirementNode(node) {
            return node.get_valueString().indexOf(REQUIREMENT_VALUE) > -1
        }

        function mayHaveSubrequirements(node) {
            return node.get_valueString().indexOf(MAY_HAVE_SUBREQS_VALUE) > -1;
        }


        // returns whether or not a request node contains an element with the given reference id
        function requestNodeContainsreferenceElement(refId, destNode) {
            for (var i = 0; i < destNode.get_childrenCount() ; i++) {
                var childNode = destNode.get_childNode(i);
                if (childNode.get_valueString().indexOf(refId) > -1) {
                    return true;
                }
            }
            return false;
        }

        function getNodeDropStyle(cancelDropping, isNodeRequirement) {
            if (cancelDropping) {
                if (isNodeRequirement) {
                    return "requirementNodeNoDrop";
                } else {
                    return "elementNodeNoDrop";
                }

            } else {
                if (isNodeRequirement) {
                    return "requirementNodeOkDrop";
                } else {
                    return "elementNodeOkDrop";
                }
            }
        }

        // parse out the reference id from the node's Value property
        function getReferenceId(elementNode) {
            var valueArray = elementNode.get_valueString().split(',');
            return valueArray[REF_ID_INDEX];
        }

        // used for debugging
        function setText(text) {
            var elem = document.getElementById('eventTester');
            elem.innerHTML = text;
        }
    </script>
    <%--<script type="text/javascript" src="Scripts/CurriculumWebDataTree.js">    
    </script>--%>

    <div class="jumbotron">
        <h1>ASP.NET</h1>
        <p class="lead">ASP.NET is a free web framework for building great Web sites and Web applications using HTML, CSS, and JavaScript.</p>
        <p><a href="http://www.asp.net" class="btn btn-primary btn-large">Learn more &raquo;</a></p>
    </div>

    <ig:WebDropDown runat="server" ID="wddTest"  Width="200">
        <Items>
            <ig:DropDownItem Text="First" Value="1" />
            <ig:DropDownItem Text="Second" Value="2" />
            <ig:DropDownItem Text="Third" Value="3" />
            <ig:DropDownItem Text="Fourth" Value="4" />
        </Items>
    </ig:WebDropDown>

    <br /><br />
    <asp:Button runat="server" ID="btnTest" Text="Test" OnClick="btnTest_Click" />
    <br />
    <br />
    <asp:Label runat="server" ID="lblSelectedItem" Text="Nothing Selected" />
    <br />
    <br />

    <ig:WebDataTree ID="wdtCurricula" runat="server" DataLoadingMessage="Please Wait"
        NodeIndent="30" Font-Size="Small" EnableAjax="true" EnableConnectorLines="true"
        SelectionType="Single" InitialExpandDepth="10" EnableViewState="false" OnNodeDropped="wdtCurricula_NodeDropped">
        <AutoPostBackFlags NodeDropped="On" />
        <ClientEvents NodeDropping="nodeDropping" DragMove="dragMove" />
        <DragDropSettings AllowDrop="True" DragDropMode="Move" DropIndicator-Visible="true"
            EnableDragDrop="true" EnableDropInsertion="true" EnableExpandOnDrop="true">
        </DragDropSettings>
        <DataBindings>
        </DataBindings>
        <Templates>
            <ig:ItemTemplate ID="RequirementTemplate" runat="server" TemplateID="RequirementTemplate">
                <Template>
                    <asp:ImageButton ID="ibEditRequirement" runat="server" AlternateText="Edit" ToolTip="Edit this requirement."
                        CausesValidation="false" CommandArgument="SetInCodeBehind" CommandName="EditRequirement"
                        ImageAlign="AbsMiddle" OnCommand="ibEditRequirement_Command" ImageUrl="~/Images/icons/edit_enabled16x16.png" />
                    <asp:ImageButton ID="ibRemoveRequirement" runat="server" AlternateText="Remove" ToolTip="Remove this requirement."
                        CausesValidation="false" CommandArgument="SetInCodeBehind" CommandName="RemoveRequirement"
                        ImageAlign="AbsMiddle" ImageUrl="~/Images/icons/delete_enabled16x16.png" OnCommand="ibRemoveRequirement_Command" />
                    <cc1:ConfirmButtonExtender ID="cbeRemoveRequirement" runat="server" ConfirmText="Are you sure you want to permanently remove this requirement?"
                        TargetControlID="ibRemoveRequirement" />
                    <asp:Label runat="server" ID="lblName" Text="Requirement" Font-Bold="true" Font-Italic="false"
                        ForeColor="#6a8fc4" />
                    <asp:Label runat="server" ID="lblType" Font-Bold="false" Font-Italic="false" />
                    &nbsp;
                                <asp:ImageButton ID="ibAdd" runat="server" AlternateText="Add" ToolTip="Add" CausesValidation="false"
                                    OnClientClick="return (false);" ImageAlign="AbsMiddle" ImageUrl="~/Images/icons/add_16.png" />
                    <cc1:HoverMenuExtender ID="hmeAdd" runat="Server" TargetControlID="ibAdd" PopupControlID="pnlHoverMenuAdd"
                        HoverCssClass="popupHover" PopupPosition="Right" OffsetX="0" OffsetY="0" PopDelay="50" />
                    <asp:Panel ID="pnlHoverMenuAdd" runat="server" CssClass="requirementNodePopMenu">
                        <div runat="server" id="divAddRequirement" class="requirementNodePopMenuItem">
                            <asp:LinkButton ID="lbAddRequirement" runat="server" CommandName="AddRequirement"
                                Text="Requirement" OnCommand="lbAddRequirement_Command" />
                        </div>
                        <div class="requirementNodePopMenuItem">
                            <asp:LinkButton ID="lbAddGlobalElement" runat="server" CommandName="AddGlobalElement"
                                Text="Global Element" OnCommand="lbAddGlobalElement_Command" />
                        </div>
                        <div class="requirementNodePopMenuItem">
                            <asp:LinkButton ID="lbAddLocalElement" runat="server" CommandName="AddLocalElement"
                                Text="Local Element" OnCommand="lbAddLocalElement_Command" />
                        </div>
                    </asp:Panel>
                </Template>
            </ig:ItemTemplate>
            <ig:ItemTemplate ID="ElementTemplate" runat="server" TemplateID="ElementTemplate">
                <Template>
                    <cc1:ConfirmButtonExtender ID="cbeRemoveElement" runat="server" ConfirmText="Are you sure you want to permanently remove this element?"
                        TargetControlID="ibRemoveElement" />
                    <asp:ImageButton ID="ibEditElement" runat="server" AlternateText="Edit" ToolTip="Edit this element."
                        Visible="false" CausesValidation="false" CommandArgument="SetInCodeBehind" CommandName="EditElement"
                        ImageAlign="AbsMiddle" OnCommand="ibEditElement_Command" ImageUrl="~/Images/icons/edit_enabled16x16.png" />
                    <asp:ImageButton ID="ibRemoveElement" runat="server" AlternateText="Remove" ToolTip="Remove this element."
                        CausesValidation="false" CommandArgument="SetInCodeBehind" CommandName="RemoveElement"
                        ImageAlign="AbsMiddle" OnCommand="ibRemoveElement_Command" ImageUrl="~/Images/icons/delete_enabled16x16.png" />
                    <asp:Label runat="server" ID="lblType" Font-Bold="false" Font-Italic="true" ForeColor="#507fbc" />
                    <asp:Label runat="server" ID="lblCreditsHours" Font-Italic="true" Font-Bold="false" />
                    <asp:Label runat="server" ID="lblName" Font-Bold="false" />
                    <asp:Label runat="server" ID="lblElementText" />
                </Template>
            </ig:ItemTemplate>
        </Templates>
    </ig:WebDataTree>


</asp:Content>
