﻿using System;
using System.Collections.Generic;
using System.Web.UI;
using System.Web.UI.WebControls;
using Infragistics.Web.UI;
using Infragistics.Web.UI.NavigationControls;
using EnsureTemplate.ClassFiles;


namespace EnsureTemplate
{
    public partial class _Default : Page
    {

        protected void Page_Init()
        {
            wdtCurricula.EnableViewState = true;
        }

        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {
                lblSelectedItem.Text = wddTest.SelectedValue;

                Guid parentGuid = Guid.NewGuid();
                RequirementNode parentdNode = new RequirementNode(parentGuid);
                RequirementNode reqNode = new RequirementNode(parentGuid);
                reqNode.AddToTree(wdtCurricula);
                reqNode.Expanded = true;
                reqNode.ExpandChildren();
            }
            //Guid childGuid = Guid.NewGuid();
            //ElementNode childNode = new ElementNode(childGuid);

            //wdtCurricula.Nodes.Add(parentdNode);
            //parentdNode.EnsureTemplate();
            //parentdNode.Nodes.Add(childNode);            
            //childNode.EnsureTemplate();
        }


        protected void ibEditRequirement_Command(object sender, CommandEventArgs e)
        {
            Guid requirementId = new Guid(e.CommandArgument.ToString());
        }

        protected void ibRemoveRequirement_Command(object sender, CommandEventArgs e)
        {
            Guid requirementId = new Guid(e.CommandArgument.ToString());
        }


        protected void lbAddRequirement_Command(object sender, CommandEventArgs e)
        {
            Guid parentRequirementId = new Guid(e.CommandArgument.ToString());
        }

        protected void lbAddGlobalElement_Command(object sender, CommandEventArgs e)
        {
            Guid parentRequirementId = new Guid(e.CommandArgument.ToString());
        }

        protected void lbAddLocalElement_Command(object sender, CommandEventArgs e)
        {
            Guid parentRequirementId = new Guid(e.CommandArgument.ToString());
        }

        protected void ibEditElement_Command(object sender, CommandEventArgs e)
        {
            Guid elementId = new Guid(e.CommandArgument.ToString());
        }

        protected void ibRemoveElement_Command(object sender, CommandEventArgs e)
        {
            Guid elementId = new Guid(e.CommandArgument.ToString());
        }

        protected void wdtCurricula_NodeDropped(object sender, DataTreeNodeDroppedEventArgs e)
        {
            string testy = "test";
            //   MoveNode(e.SourceNodes[0], e.DestNode, e.DragDropPoint);
        }

        protected void btnTest_Click(object sender, EventArgs e)
        {
            lblSelectedItem.Text = wddTest.SelectedValue;
        }
    }
}